// Copyright (C) 2000 Jean-Marc Valin


#ifndef AUDIO_PROPERTIES_H
#define AUDIO_PROPERTIES_H

#include <gnome.h>
#include "AudioDataInfo.h"
#include <tree.h>
#include <parser.h>

class AudioProperties {
  protected:
   GtkWidget *dialog;
   AudioDataInfo *info;

   GtkToggleButton *(enc_buttons[AudioDataInfo::last]);
   GtkToggleButton *(stereo_buttons[2]);
   GtkEntry *sampling_entr;
   GtkEntry *frame_size_entr;
   GtkEntry *frame_advance_entr;
  public:
   AudioDataInfo *curr_info;
  public:
   AudioProperties();
   AudioProperties(const AudioProperties &proj_info);
   AudioProperties(xmlNodePtr prop);
   ~AudioProperties();
   void setup();
   void show();
   void apply();
   void change();
   AudioDataInfo *getInfo() {return info;}
   void save (xmlNode *root);
};

#endif
