// Copyright (C) 1999-2000 Jean-Marc Valin

#ifndef GLPLOT_H
#define GLPLOT_H

#include <GL/gl.h>
#include <GL/glu.h>
#include <gtk/gtk.h>
#include <gtkgl/gtkglarea.h>

#include "AudioData.h"
#include <vector>
#include "SourceManager.h"

class GLPlot {
  protected:
   GtkWidget* glarea;
   //vector <AudioData *> sources;
   SourceManager *sources;

  public:

   GLPlot(SourceManager *_sources);
   virtual ~GLPlot();
   virtual void dispose();
   virtual void plot()=0;
   int draw(GdkEventExpose* event);
   void redraw();
   virtual int reshape(GdkEventConfigure* event);
   virtual int button_release (GdkEventButton* event);
   virtual int button_press (GdkEventButton* event);
   virtual int motion_notify (GdkEventMotion* event);

   //void addSource(AudioData *src) {sources.insert(sources.end(), src);}
   GtkWidget *getGLArea() {return glarea;}
};


#endif
