// Copyright (C) 2000 Jean-Marc Valin

#include <iostream>
#include <gnome.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <string>
#include "GLPlot.h"
#include "VisixProject.h"

#include "SourceManager.h"
#include "ExternalApp.h"

class VisixApp : public ExternalApp{
  protected:

   GtkWidget *container;

   GtkWidget *workspace_menu;

   GtkWidget *workspace_root;

   GtkWidget *app;

   vector <VisixProject *> projects;

   GtkWidget *dock;

   SourceManager mainSources;

   string docName;

   bool untitled;
  public:
   VisixApp();
   ~VisixApp() {resetWorkspace();}

   void workspacePopup(GdkEvent *event);
   void addPlot(GLPlot *plot);
   void addProject(const string &name);
   GtkWidget *getApp() {return app;}
   void addSource(AudioData *source) {mainSources.addSource(source);}
   void removeSource(AudioData *source) {mainSources.removeSource(source);}
   SourceManager *getManager() {return &mainSources;}
   void save();
   void saveAs();
   void load(const string &name);
   void setName(const string &_name);
   void resetWorkspace();
};
